/*====  Not-a-code  ====*/

#define  x           0x00

/*====  Control codes  ====*/

#define  NBSP        0x01
#define  SHY         0x02

/*====  Russian cyrillics  ====*/

#define  CapA        0x10
#define  CapB        0x11
#define  CapV        0x12
#define  CapG        0x13
#define  CapD        0x14
#define  CapE        0x15
#define  CapZh       0x16
#define  CapZ        0x17
#define  CapI        0x18
#define  CapJ        0x19
#define  CapK        0x1A
#define  CapL        0x1B
#define  CapM        0x1C
#define  CapN        0x1D
#define  CapO        0x1E
#define  CapP        0x1F
#define  CapR        0x20
#define  CapS        0x21
#define  CapT        0x22
#define  CapU        0x23
#define  CapF        0x24
#define  CapH        0x25
#define  CapTse      0x26
#define  CapChe      0x27
#define  CapSha      0x28
#define  CapShcha    0x29
#define  CapHard     0x2A
#define  CapYeri     0x2B
#define  CapSoft     0x2C
#define  CapRevE     0x2D
#define  CapYu       0x2E
#define  CapYa       0x2F

#define  SmallA      0x30
#define  SmallB      0x31
#define  SmallV      0x32
#define  SmallG      0x33
#define  SmallD      0x34
#define  SmallE      0x35
#define  SmallZh     0x36
#define  SmallZ      0x37
#define  SmallI      0x38
#define  SmallJ      0x39
#define  SmallK      0x3A
#define  SmallL      0x3B
#define  SmallM      0x3C
#define  SmallN      0x3D
#define  SmallO      0x3E
#define  SmallP      0x3F
#define  SmallR      0x40
#define  SmallS      0x41
#define  SmallT      0x42
#define  SmallU      0x43
#define  SmallF      0x44
#define  SmallH      0x45
#define  SmallTse    0x46
#define  SmallChe    0x47
#define  SmallSha    0x48
#define  SmallShcha  0x49
#define  SmallHard   0x4A
#define  SmallYeri   0x4B
#define  SmallSoft   0x4C
#define  SmallRevE   0x4D
#define  SmallYu     0x4E
#define  SmallYa     0x4F

#define  CapYo       0x50
#define  SmallYo     0x51

/*====  Other cyrillics  ====*/

#define  CapDje        0x52
#define  CapGje        0x53
#define  CapIe         0x54
#define  CapDze        0x55
#define  CapI_lat      0x56
#define  CapYi         0x57
#define  CapJe         0x58
#define  CapLje        0x59
#define  CapNje        0x5A
#define  CapTshe       0x5B
#define  CapKje        0x5C
#define  CapShortU     0x5D
#define  CapDzhe       0x5E
#define  CapGhe        0x5F

#define  SmallDje      0x60
#define  SmallGje      0x61
#define  SmallIe       0x62
#define  SmallDze      0x63
#define  SmallI_lat    0x64
#define  SmallYi       0x65
#define  SmallJe       0x66
#define  SmallLje      0x67
#define  SmallNje      0x68
#define  SmallTshe     0x69
#define  SmallKje      0x6A
#define  SmallShortU   0x6B
#define  SmallDzhe     0x6C
#define  SmallGhe      0x6D

/*====  Pseudographics  ====*/

#define  BoxVs         0x70
#define  BoxHs         0x71
#define  BoxVd         0x72
#define  BoxHd         0x73

/*-----------------*/

#define  BoxDsRs       0x74
#define  BoxDsHs       0x75
#define  BoxDsLs       0x76

#define  BoxVsRs       0x77
#define  BoxVsHs       0x78
#define  BoxVsLs       0x79

#define  BoxUsRs       0x7A
#define  BoxUsHs       0x7B
#define  BoxUsLs       0x7C

/*-----------------*/

#define  BoxDsRd       0x7D
#define  BoxDsHd       0x7E
#define  BoxDsLd       0x7F

#define  BoxVsRd       0x80
#define  BoxVsHd       0x81
#define  BoxVsLd       0x82

#define  BoxUsRd       0x83
#define  BoxUsHd       0x84
#define  BoxUsLd       0x85

/*-----------------*/

#define  BoxDdRs       0x86
#define  BoxDdHs       0x87
#define  BoxDdLs       0x88

#define  BoxVdRs       0x89
#define  BoxVdHs       0x8A
#define  BoxVdLs       0x8B

#define  BoxUdRs       0x8C
#define  BoxUdHs       0x8D
#define  BoxUdLs       0x8E

/*-----------------*/

#define  BoxDdRd       0x8F
#define  BoxDdHd       0x90
#define  BoxDdLd       0x91

#define  BoxVdRd       0x92
#define  BoxVdHd       0x93
#define  BoxVdLd       0x94

#define  BoxUdRd       0x95
#define  BoxUdHd       0x96
#define  BoxUdLd       0x97

/*-----------------*/

#define  ShadeLight    0x97
#define  ShadeMedium   0x98
#define  ShadeDark     0x99
#define  BlockWhole    0x9A
#define  BlockTop      0x9B
#define  BlockBottom   0x9C
#define  BlockLeft     0x9D
#define  BlockRight    0x9E

/*====  Mathematical symbols  ====*/

#define  PlusMinus        0x9F
#define  LessOrEqu        0xA0
#define  MoreOrEqu        0xA1
#define  IntegralTop      0xA2
#define  IntegralBottom   0xA3
#define  Div              0xA4
#define  AlmostEqu        0xA5
#define  Root             0xA6
#define  PowerN           0xA7
#define  Power2           0xA8
#define  NotEqu           0xA9
#define  Infinity         0xAA
#define  FScript          0xAB
#define  EmptySet         0xAC
#define  MemberOf         0xAD
#define  Intersection     0xAE

/*====  Misc symbols  ====*/

#define  SQuoteBottom      0xAF
#define  SQuoteOpen        0xB0
#define  SQuoteClose       0xB1
#define  DQuoteBottom      0xB2
#define  DQuoteOpen        0xB3
#define  DQuoteClose       0xB4
#define  SLeftGuillemet    0xB5
#define  SRightGuillemet   0xB6
#define  DLeftGuillemet    0xB7
#define  DRightGuillemet   0xB8

#define  Ellipsis          0xB9
#define  EnDash            0xBA
#define  EmDash            0xBB
#define  Paragraph         0xBC
#define  ParaEnd           0xBD
#define  PerMille          0xBE
#define  Number            0xBF
#define  Pound             0xC0
#define  Degree            0xC1

#define  Trademark         0xC2
#define  Registered        0xC3
#define  Copyright         0xC4

#define  ThreeHor          0xC5
#define  SmallSquare       0xC6

#define  Dagger            0xC7
#define  DDagger           0xC8
#define  Bullet            0xC9
#define  CenterDot         0xCA
#define  Currency          0xCB
#define  BrokenVertBar     0xCC
#define  NotSign           0xCD
#define  ArrowLeft         0xCE
#define  ArrowRight        0xCF
#define  ArrowUp           0xD0
#define  ArrowDown         0xD1

/*====  Some greek symbols  ====*/

#define  CapGamma      0xD2
#define  CapDelta      0xD3
#define  CapSigma      0xD4
#define  CapFi         0xD5
#define  CapOmega      0xD6

#define  SmallAlpha    0xD7
#define  SmallBeta     0xD8
#define  SmallDelta    0xD9
#define  SmallTeta     0xDA
#define  SmallMu       0xDB
#define  SmallPi       0xDC
#define  SmallSigma    0xDD
#define  SmallTau      0xDE

/*====  More pseudographics  ====*/
/* Slash-like corners */

#define  BoxDL         0xDF
#define  BoxDR         0xE0
#define  BoxUL         0xE1
#define  BoxUR         0xE2

#define ASCII_SUBST  256
#define N_CHARSETS   5

typedef unsigned char BYTE;
typedef struct
{
    int    cn;
    BYTE   *table;
} _charset;

extern  BYTE  CharsetAlternative[];
extern  BYTE  CharsetISO_8859[];
extern  BYTE  CharsetKOI8R[];
extern  BYTE  CharsetMacintosh[];
extern  BYTE  CharsetWindows[];

extern  int   SubstTable[][2];
extern  BYTE  RarePairsTable[32][32];

extern  _charset charsets[N_CHARSETS];
